//Carlos Gershenson
//carlos@jlagunez.iquimica.unam.mx

import java.util.*;
import java.io.*; 
import Scanner;
import Parser;
import Rule;

class Parts {//register for left and right parts of a symbol
  int id;
  Vector pd,pi;
  public Parts() {
    id = 0;//id of symbol
    pi = new Vector ((int)5,(int)3);//left parts
    pd = new Vector ((int)5,(int)3);//right parts
  }
}

//main class (class to be compiled and to be ran)
public class C {
  static Scanner scanner;
  static Parser parser;
  public static Hashtable tokens,V,vars;
  public static Stack sems;
  public static Vector N,T,P, vvars;
  public static final String TOKENS = "()+-*/^<>=!; ";
  public static Parts[] parts;
  public static int sizeN,sizeP,sizeT;
  static boolean error;
  public C() {//initializes grammatic, hashtables, rules, parts, etc.
    error = false;
    tokens = new Hashtable();//tokens hashtable
    vars = new Hashtable();//variables hashtable
    vvars = new Vector((int)10,(int)3);//variables vector
    sems = new Stack();//semantic stack
    V = new Hashtable();//set of all symbols (N union T)
    N = new Vector ((int)30,(int)3);//non-terminal symbols
    T = new Vector ((int)30,(int)3);//terminal symbols
    P = new Vector ((int)40,(int)3);//production rules
    char ch = '';
    String str = "";
    StringTokenizer st;
    Rule rule = new Rule();
    Integer Int;
    int ind = 1;
    FileInputStream istream = null ;
    try {//read grammatic from file
      istream = new FileInputStream("calc.sem");
      istream.skip(3);
      while (ch != '\n') {
        str = "";
        ch = (char)istream.read();
        while ((ch != ' ')&&(ch != '\n')) {//read terminal symbol
          str+= ch;
          ch = (char)istream.read();
        }
        if (ch != '\n') {//add terminal symbol
          //System.out.println(str+" "+ind);          
          tokens.put(str, new Integer(ind));
          V.put(str, new Integer(ind));
          T.addElement(str);
          ind++;
        }
      }
      ch = '';
      istream.skip(3);
      while (ch != '\n') {
        str = "";
        ch = (char)istream.read();
        while ((ch != ' ')&&(ch != '\n')) {//read non-terminal symbol
          str+= ch;
          ch = (char)istream.read();
        }
        if (ch != '\n') {//add non-terminal symbol
          //System.out.println(str+" "+ind);          
          V.put(str, new Integer(ind));
          N.addElement(str);
          ind++;
        }
      }
      ch = '';
      istream.skip(3);
      while (ch != '|') {//read production rule
        str = "";
        ch = (char)istream.read();
        if(ch != '|') {
          rule = new Rule();
          while (ch != '~') {//read "if" part
            str+= ch;
            ch = (char)istream.read();
          }
          Int = (Integer)V.get(str);
          rule.i = Int.intValue();
          //System.out.print(str+" "+rule.i+"->");
          str = "";
          ch = (char)istream.read();
          while (ch != '\n') {//read "then" part
            str+= ch;
            ch = (char)istream.read();
          }
          st = new StringTokenizer(str,TOKENS,true);
          while (st.hasMoreTokens()) {//check for composed tokens like <= or >=
            str = st.nextToken();
            if ((str.compareTo("!") == 0)||(str.compareTo("<") == 0)||(str.compareTo(">") == 0)) {
              String s3 = st.nextToken();
              String s2 = str+s3;
              if ((s2.compareTo("!=") == 0)||(s2.compareTo("<=") == 0)||(s2.compareTo(">=") == 0)) { //token was <= or >= or !=
                str = s2;
              } else { //restore st
                while (st.hasMoreTokens()) {
                  s3+= st.nextToken();
                }
                st = new StringTokenizer(s3,C.TOKENS,true);
              }
            }
            Int = (Integer)V.get(str);
            if (Int != null) {
              rule.t.addElement(Int);
              //System.out.println(str+" "+Int+" ");
            }
          }
          //System.out.println();
        }
        P.addElement(rule); //add rule
      }
      istream.close();
    } catch(IOException ioe) {
      System.out.println(ioe.getMessage());
    }
    tokens.remove("R");//R and var are just to set the hashtable, they aren'r "real" terminal symbols
    tokens.remove("var");
    sizeP = P.size();
    sizeN = N.size();
    sizeT = T.size();
    getParts(sizeN);
  }
  void getParts(int size) {//generates left and right parts of symbols and saves them in variable parts, to be used by the Parser
    Parts part;
    Rule rule;
    Integer Int;
    int i;
    parts = new Parts[size];
    for (i = 0;i < size;i++) {
      part = new Parts();
      part.id = i+T.size()+1;
      parts[i] = part;
    }
    for (i = 0;i < P.size();i++) {
      rule = (Rule)P.elementAt(i);
      //System.out.print(i+" "+rule.i+" "+rule.t.size()+ " "+rule.t.elementAt(0)+" "+rule.t.elementAt(rule.t.size()-1)+"  ");
      Int = (Integer)rule.t.elementAt(0);
      if( ! parts[rule.i-T.size()-1].pi.contains(Int))
        parts[rule.i-T.size()-1].pi.addElement(Int);
      Int = (Integer)rule.t.elementAt(rule.t.size()-1);
      if( ! parts[rule.i-T.size()-1].pd.contains(Int))
        parts[rule.i-T.size()-1].pd.addElement(Int);
    }
    for (i = 0;i < size;i++) {
      for (int j = 0;j < size;j++) {
        if (parts[i].pi.contains(new Integer(parts[j].id)))
          for (int k = 0;k < parts[j].pi.size();k++) {
          Int = (Integer)parts[j].pi.elementAt(k);
          if( ! parts[i].pi.contains(Int))
            parts[i].pi.addElement(Int);
        }
        if (parts[i].pd.contains(new Integer(parts[j].id)))
          for (int k = 0;k < parts[j].pd.size();k++) {
          Int = (Integer)parts[j].pd.elementAt(k);
          if( ! parts[i].pd.contains(Int))
            parts[i].pd.addElement(Int);
        }
      }
    }
    /*for (i = 0;i < size;i++) {
     System.out.print(parts[i].id+"->");
     for (int j = 0;j < parts[i].pi.size();j++) {
     System.out.print(parts[i].pi.elementAt(j)+" ");
    }
     System.out.print("|");
     for (int j = 0;j < parts[i].pd.size();j++) {
     System.out.print(parts[i].pd.elementAt(j)+" ");
    }
     System.out.println("");
    } */
  }
  
  static void generatecode (int rule) {//generates code in the semantic stack depending on rule
                                       //used to reduce by the Parser
    String s1, s2, s3;
    switch(rule){
      case 0:
        s1=(String)sems.pop();
        sems.push(new String(vars.size()+" "+s1+" WRITE END"));
      break;
      case 2:
        s1=(String)sems.pop();
        s2=(String)sems.pop();
        s3=(String)sems.pop();
        sems.push(new String(s3+" "+s1+" "+s2));
      break;
      case 4:
        s1=(String)sems.pop();
        s2=(String)sems.pop();
        s3=(String)sems.pop();
        sems.push(new String(s3+" "+s1+" "+s2));
      break;
      case 6:
        s1=(String)sems.pop();
        s2=(String)sems.pop();
        s3=(String)sems.pop();
        sems.push(new String(s3+" "+s1+" "+s2));
      break;
      case 8:
        s1=(String)sems.pop();
        s2=(String)sems.pop();
        s3=(String)sems.pop();
        sems.push(new String(s3+" "+s1+" "+s2));
      break;
      case 10:
        s1=(String)sems.pop();
        s2=(String)sems.pop();
        s3=(String)sems.pop();
        sems.push(new String(s3+" "+s1+" "+s2));
      break;
      case 12:
        s1=(String)sems.pop();
        sems.push(new String(s1+" NEG"));
      break;
      case 14:
        sems.push(new String("PushVAL "+scanner.number));
      break;
      case 15:
        if (vars.get(scanner.var)==null){
          vars.put(scanner.var,new Integer(vars.size()+1));
          vvars.addElement(scanner.var);
        }
        sems.push(new String("PushVAR "+vars.get(scanner.var)));
      break;
      case 16:
        sems.push(new String("AND"));
      break;
      case 17:
        sems.push(new String("OR"));
      break;
      case 18:
        sems.push(new String("LESS"));
      break;
      case 19:
        sems.push(new String("GREAT"));
      break;
      case 20:
        sems.push(new String("LESST"));
      break;
      case 21:
        sems.push(new String("GREATT"));
      break;
      case 22:
        sems.push(new String("EQ"));
      break;
      case 23:
        sems.push(new String("NEQ"));
      break;
      case 24:
        sems.push(new String("PLUS"));
      break;
      case 25:
        sems.push(new String("MINUS"));
      break;
      case 26:
        sems.push(new String("MUL"));
      break;
      case 27:
        sems.push(new String("DIV"));
      break;
      case 28:
        sems.push(new String("POT"));
      break;
      case 29:
        s1=(String)sems.pop();
        sems.push(new String(s1+" SIN"));
      break;
      case 30:
        s1=(String)sems.pop();
        sems.push(new String(s1+" COS"));
      break;
      case 31:
        s1=(String)sems.pop();
        sems.push(new String(s1+" TAN"));
      break;
    }
  }
  
  public static void main(String[] args) {
    C compiler = new C();//construct  C
    String code = args[0];//get code from prompt ("" advised to be used)
    scanner = new Scanner(code);//init scanner
    parser = new Parser();//init Parser
    System.out.println(code);
    parser.es = scanner.getToken();//begin to parse
    parser.ss.push(new Integer(parser.es));
    parser.es = scanner.getToken(); 
    while(( ! scanner.error)&&( ! parser.error)&&(parser.es > 0)) {//parse
      parser.showstack(parser.ss);
      System.out.println("| "+parser.es);
      Integer tope = (Integer)parser.ss.peek();
      if (parser.M(tope.intValue(),parser.es) == 0) {//error
        parser.error = true;
      } else if (parser.M(tope.intValue(),parser.es) == 1) {//keep reading tokens
        parser.ss.push(new Integer(parser.es));
        parser.es = scanner.getToken();
      } else if (parser.M(tope.intValue(),parser.es) == 2) {//reduce and generate code
        if ( ! parser.reduce()) error = true;
        generatecode(parser.rule);
        //System.out.println("reduced by rule #"+parser.rule);
      }
    }
    parser.showstack(parser.ss);
    System.out.println("| "+parser.es);
    if ( ! parser.reduce()) error = true;
    generatecode(parser.rule);
    //System.out.println("reduced by rule #"+parser.rule);
    parser.showstack(parser.ss);
    System.out.println("| "+parser.es);
    Integer S = (Integer)parser.ss.peek();
    if ((S.intValue() != sizeT+1)||(parser.es != 0))
      error = true;
    if(scanner.error) System.out.println("Lexicographical error");
    if(parser.error) System.out.println("Syntactic error");
    if(error) System.out.println("Semantic error"); 
    if((scanner.error)||(parser.error)) error=true;
    String vmcode=(String)sems.peek();
    System.out.println("Top of semantic stack:\n"+vmcode);
    if (!error){
      X x= new X(vmcode);//execute code with X VM
    }
    /*Integer u,v;
     u=(Integer)V.get("ExpLog");
     v=(Integer)V.get(";");
     System.out.println(parser.M(u.intValue(),v.intValue()));
     u=(Integer)V.get("opAdd");
     v=(Integer)V.get("var");
     System.out.println(u+" "+v);
     System.out.println(parser.M(u.intValue(),v.intValue()));
     u=(Integer)V.get("Term");
     v=(Integer)V.get(")");
     System.out.println(parser.M(u.intValue(),v.intValue()));
     u=(Integer)V.get(")");
     v=(Integer)V.get(")");
     System.out.println(parser.M(u.intValue(),v.intValue()));
     u=(Integer)V.get("Term");
     v=(Integer)V.get("Fact");
     System.out.println(parser.M(u.intValue(),v.intValue()));
     */
    /*while (scanner.moreTokens()){
     System.out.println(scanner.getToken()+" "+scanner.number+" "+scanner.var);
    } */
  }
}