// {$R ExpressionGenerator.JFM}

//Carlos Gershenson
//carlos@jlagunez.iquimica.unam.mx

import java.awt.*;
import java.applet.Applet;
import java.util.*;

class Monomy{
  long c=1;//coeficient
  String v="";//variables
  void multiply (Monomy mon){
    int i=0,j=0;
    char tmp;
    if (v.equals("")) v=mon.v;
    else if (!(mon.v.equals(""))){
      v+=mon.v;
      char [] a1= v.toCharArray();
      for (i=0;i<v.length();i++)
        for (j=i+1;j<v.length();j++)
          if (a1[j]<a1[i]){
            tmp=a1[j];
            a1[j]=a1[i];
            a1[i]=tmp;
          }
      v=new String(a1);
    }
    c*=mon.c;
    if (c==0)
      v="";
  }
  String print(){
    String str="";
    if ((c!=1)||((v.equals(""))))
      str+=String.valueOf(c);
    str+=v;
    return str;
  }
}

class Expression{
  Vector m = new Vector((int)20,(int)5);//monomies
  char op='|';//+,*, or reduced expr(|)
  Expression p=null;//predecesor
  Expression s=null;//succesor
  public Expression(){
    Monomy mon=new Monomy();
    ExpressionGenerator.cnt++;
    int tmp;
    if (ExpressionGenerator.cnt<ExpressionGenerator.min)
      tmp=(int)(2+Math.floor(ExpressionGenerator.rnd.nextFloat()*2));
    else if (ExpressionGenerator.cnt>ExpressionGenerator.max)
      tmp=(int)Math.floor(ExpressionGenerator.rnd.nextFloat()*2);
    else    
      tmp=(int)Math.floor(ExpressionGenerator.rnd.nextFloat()*4);
    switch(tmp){
      case 0://number
        op='|';
        mon.c=(int)Math.floor(ExpressionGenerator.rnd.nextFloat()*ExpressionGenerator.maxint);
        m.addElement(mon);
        break;
      case 1://variable
        op='|';
        Character chr=(Character)ExpressionGenerator.a.elementAt((int)(ExpressionGenerator.rnd.nextFloat()*ExpressionGenerator.a.size()));
        char[] arr=new char[1];
        arr[0]=chr.charValue();
        mon.v=new String(arr);
        m.addElement(mon);
        break;
      case 2://+
        op='+';
        this.p=new Expression();
        this.s=new Expression();
        break;
      case 3://*
        op='*';
        this.p=new Expression();
        this.s=new Expression();
        break;
    }
  }
  String show(){
    int i;
    String str="(";
    if (op=='|'){
      if (m.size()>0){
        Monomy mon;
        for (i=0;i<m.size();i++){
          mon=(Monomy)m.elementAt(i);
          str+=mon.print();
          if (i<(m.size()-1))
            str+=" + ";
        }
      }else{
        str+=0;
      }
    }else{
      str+=p.show();
      if (op=='+')
        str+=" + ";
      if (op=='*')
        str+="*";
      str+=s.show();
    }
    str+=")";
    return str;
  }
  void reduce(){
    int i,j;
    boolean flag;
    Monomy aux=new Monomy(),aux2=new Monomy(),aux3=new Monomy();
    if (op=='+'){
      p.reduce();
      s.reduce();
      for (i=0;i<s.m.size();i++){
        aux=(Monomy)s.m.elementAt(i);
        for (j=0;j<p.m.size();j++){
          aux2=(Monomy)p.m.elementAt(j);
          if (aux.v.equals(aux2.v)){
            aux.c+=aux2.c;
            p.m.removeElementAt(j);
          }
        }
        if (aux.c!=0)m.addElement(aux);
      }
      for (j=0;j<p.m.size();j++){
        aux=(Monomy)p.m.elementAt(j);
        if (aux.c!=0)m.addElement(aux);
      }
      op='|';  
    }else
    if (op=='*'){
      p.reduce();
      s.reduce();
      for (i=0;i<s.m.size();i++){
        aux=(Monomy)s.m.elementAt(i);
        for (j=0;j<p.m.size();j++){
          aux2=(Monomy)p.m.elementAt(j);
          aux3=new Monomy();
          aux3.v=aux.v;
          aux3.c=aux.c;
          aux3.multiply(aux2);          
          if (aux3.c!=0) m.addElement(aux3);
        }
      }
      op='|';  
    }
  }
  
}

// Class ExpressionGenerator
public class ExpressionGenerator extends Applet
{
    Expression e;
    public static Vector a=new Vector((int)20,(int)5);//alphabet
    public static int maxint=1000;
    public static int cnt=0;
    public static int min,max;
    public static Random rnd = new Random();
    final int MenuBarHeight = 0;
    // Component Declaration
    public TextArea output;
    public Label Label1;
    public Label Label2;
    public Label Label3;
    public TextField alphabetf;
    public TextField maxexprf;
    public TextField minexprf;
    public Button go;
    public Button clear;
    public Label Label4;
    public TextField maxintf;
    public Image Image1;
    // End of Component Declaration

    // init()
    public void init()
    {
        // Frame Initialization
        setForeground(Color.blue);
        setBackground(Color.white);
        setFont(new Font("TimesRoman",Font.BOLD,12));
        setLayout(null);
        // End of Frame Initialization

        // Component Initialization
        output = new TextArea("Welcome to Random Expression Generator\n");
        output.setForeground(Color.black);
        output.setBackground(Color.white);
        output.setFont(new Font("Dialog",Font.BOLD,10));
        Label1 = new Label("Alphabet:",Label.LEFT);
        Label1.setFont(new Font("Dialog",Font.BOLD,12));
        Label2 = new Label("Max expr:",Label.LEFT);
        Label2.setFont(new Font("Dialog",Font.BOLD,12));
        Label3 = new Label("Min expr:",Label.LEFT);
        Label3.setFont(new Font("Dialog",Font.BOLD,12));
        alphabetf = new TextField("x y z a b c");
        alphabetf.setForeground(Color.black);
        alphabetf.setBackground(Color.white);
        alphabetf.setFont(new Font("Dialog",Font.BOLD,12));
        maxexprf = new TextField("30");
        maxexprf.setForeground(Color.black);
        maxexprf.setBackground(Color.white);
        maxexprf.setFont(new Font("Dialog",Font.BOLD,12));
        minexprf = new TextField("4");
        minexprf.setForeground(Color.black);
        minexprf.setBackground(Color.white);
        minexprf.setFont(new Font("Dialog",Font.BOLD,12));
        go = new Button("go");
        go.setFont(new Font("Dialog",Font.BOLD,42));
        clear = new Button("clear");
        clear.setFont(new Font("Dialog",Font.BOLD,12));
        Label4 = new Label("Max int :",Label.LEFT);
        Label4.setFont(new Font("Dialog",Font.BOLD,12));
        maxintf = new TextField("1000");
        maxintf.setForeground(Color.black);
        maxintf.setBackground(Color.white);
        maxintf.setFont(new Font("Dialog",Font.BOLD,12));
        Image1 = getImage(getCodeBase(), "Eye.gif");
        // End of Component Initialization

        // Add()s
        add(maxintf);
        add(Label4);
        add(clear);
        add(go);
        add(minexprf);
        add(maxexprf);
        add(alphabetf);
        add(Label3);
        add(Label2);
        add(Label1);
        add(output);
        // End of Add()s

        InitialPositionSet();
    } // End of init()

    // start()
    public void start()
    {
    } // End of start()

    // stop()
    public void stop()
    {
    } // End of stop()

    // destroy()
    public void destroy()
    {
    } // End of destroy()

    public void paint(Graphics g)
    {
        // paint()
        g.drawImage(Image1, 273,47,57,55, this);
        // End of paint()
    }

    public void InitialPositionSet()
    {
        // InitialPositionSet()
        resize(532,319);
        output.reshape(12,148+MenuBarHeight,501,141);
        Label1.reshape(21,18+MenuBarHeight,80,19);
        Label2.reshape(20,49+MenuBarHeight,77,19);
        Label3.reshape(20,78+MenuBarHeight,78,19);
        alphabetf.reshape(107,14+MenuBarHeight,260,27);
        maxexprf.reshape(107,46+MenuBarHeight,121,27);
        minexprf.reshape(107,76+MenuBarHeight,121,27);
        go.reshape(378,11+MenuBarHeight,135,120);
        clear.reshape(266,107+MenuBarHeight,75,25);
        Label4.reshape(20,107+MenuBarHeight,67,19);
        maxintf.reshape(107,106+MenuBarHeight,121,27);
        // End of InitialPositionSet()
    }

    public boolean handleEvent(Event evt)
    {
        // handleEvent()
        if (evt.id == Event.WINDOW_DESTROY && evt.target == this) ExpressionGenerator_WindowDestroy(evt.target);
        else if (evt.id == Event.ACTION_EVENT && evt.target == clear) clearOutput(evt.target);
        else if (evt.id == Event.ACTION_EVENT && evt.target == go) go(evt.target);
        // End of handleEvent()

        return super.handleEvent(evt);
    }

    // Event Handling Routines
    public void ExpressionGenerator_WindowDestroy(Object target)
    {
        System.exit(0);
    }

    public void clearOutput(Object target){
      output.setText("");
    }

    public void go(Object target){
      boolean ok=true;
      int i;
      Character ch;
      String str="";
      try {
        maxint = Integer.valueOf(maxintf.getText()).intValue();
        max = Integer.valueOf(maxexprf.getText()).intValue();
        min = Integer.valueOf(minexprf.getText()).intValue();
      }
      catch (NumberFormatException e) {
        output.appendText("Please fill the fileds correctly!\n");
        ok=false;
      }
      getalph();
      if ((maxint<0)||(max<0)||(min<0)||(a.size()==0)){
        ok=false;
        output.appendText("Please fill the fileds with appropiate amounts!\n");
      }
      if (ok && (a.size()>0)){
        maxint++;
        for(i=0;i<a.size();i++){
          ch=(Character)a.elementAt(i);
          str+=ch.charValue();
          str+=" ";
        }
        output.appendText("Alphabet: "+str+"\n");
        cnt=0;
        e=new Expression();       
        output.appendText(e.show()+"\n");
        e.reduce();
        output.appendText(e.show()+"\n");
      }
    }
    // End of Event Handling Routines

    void getalph(){
      String s=new String(alphabetf.getText());
      int i = 0;
      char ch;
      a.removeAllElements();
      while(i < s.length()) {
        ch = s.charAt(i);
        i++;
        if (( ! Character.isSpace(ch))&&(!(a.contains(new Character(ch)))))
          a.addElement(new Character(ch));
      }
    }

} // End of Class ExpressionGenerator