// {$R L.JFM}

import java.awt.*;
import java.applet.Applet;
import java.util.*;

class Points{
  public float x1,y1,x2,y2;
  public Points(float X1,float Y1,float X2,float Y2){
    x1=X1;y1=Y1;x2=X2;y2=Y2;
  }
  String show(){
    return new String(String.valueOf(x1)+","+String.valueOf(y1)+","+
                      String.valueOf(x2)+","+String.valueOf(y2));
  }
}

// Class L
public class L extends Applet
{
  Vector points=new Vector ((int)20,(int)3);
  Vector rules=new Vector ((int)20,(int)3);
  float alfa=0,a=60;//direction alfa and turn angle
  float l=50;//length
  int r=0;//recursions for F
  float xa=0,ya=0;//previous coords.
  float xmin=xa,xmax=xa+(float)0.0001,ymin=ya,ymax=ya+(float)0.0001;
  String axiom;
  final int xini=300,yini=20,width=400,height=400;
  final int MenuBarHeight = 0;
  
  // Component Declaration
  public TextField input;
  public TextArea output;
  public Button plotB;
  public Button helpB;
  public Button clearB;
  public Button resetB;
  // End of Component Declaration
  
  // init()
  public void init()
  {
    // Frame Initialization
    setForeground(Color.black);
    setBackground(Color.white);
    setFont(new Font("Dialog",Font.BOLD,12));
    setLayout(null);
    // End of Frame Initialization
    
    // Component Initialization
    input = new TextField("");
    input.setForeground(Color.black);
    input.setBackground(Color.white);
    input.setFont(new Font("TimesRoman",Font.PLAIN,12));
    output = new TextArea("Welcome to Lindenmayer-Systems Generator\nCopyright Gershenson Technologies, 2000\n");
    output.setForeground(Color.black);
    output.setBackground(Color.white);
    output.setFont(new Font("TimesRoman",Font.PLAIN,12));
    plotB = new Button("Plot Axiom");
    plotB.setFont(new Font("Dialog",Font.BOLD,12));
    helpB = new Button("Help!");
    helpB.setFont(new Font("Dialog",Font.BOLD,12));
    clearB = new Button("Clear Output");
    clearB.setFont(new Font("Dialog",Font.BOLD,12));
    resetB = new Button("Reset");
    resetB.setFont(new Font("Dialog",Font.BOLD,12));
    // End of Component Initialization
    
    // Add()s
    add(resetB);
    add(clearB);
    add(helpB);
    add(plotB);
    add(output);
    add(input);
    // End of Add()s
    
    InitialPositionSet();
  } // End of init()
  
  // start()
  public void start()
  {
  } // End of start()
  
  // stop()
  public void stop()
  {
  } // End of stop()
  
  // destroy()
  public void destroy()
  {
  } // End of destroy()
  
  public void paint(Graphics g)
  {
    // paint()
    float scale;
    g.drawRect(xini-2,yini-2,width+2,height+2);
        if ((xmax-xmin)/width>(ymax-ymin)/height){
          scale=((xmax-xmin)/width);
        }else{
          scale=((ymax-ymin)/height);
        }
/*output.appendText("xmin"+String.valueOf(xmin)+"\n");
output.appendText("ymin"+String.valueOf(ymin)+"\n");
output.appendText("xmax"+String.valueOf(xmax)+"\n");
output.appendText("ymax"+String.valueOf(ymax)+"\n");
output.appendText("scale"+String.valueOf(scale)+"\n");
output.appendText(String.valueOf(points.size())+"\n");*/
        g.setColor(Color.blue);
        for (int i=0;i<points.size();i++){
          Points p=(Points)points.elementAt(i);
/*output.appendText("p "+p.show()+"\n");
output.appendText("  "+String.valueOf((int)((p.x1/scale)+(width/2)+xini))+"\n");
output.appendText("  "+String.valueOf((int)((p.y1/scale)+(height/2)+yini))+"\n");
output.appendText("  "+String.valueOf((int)((p.x2/scale)+(width/2)+xini))+"\n");
output.appendText("  "+String.valueOf((int)((p.y2/scale)+(height/2)+yini))+"\n");*/
          g.drawLine((int)((p.x1/scale)-(xmin/scale)+xini),(int)((p.y1/scale)-(ymin/scale)+yini),
                     (int)((p.x2/scale)-(xmin/scale)+xini),(int)((p.y2/scale)-(ymin/scale)+yini));
        }
        g.setColor(Color.black);
    // End of paint()
  }
  
  public void InitialPositionSet()
  {
    // InitialPositionSet()
    resize(707,415);
    input.reshape(13,240+MenuBarHeight,280,27);
    output.reshape(13,20+MenuBarHeight,280,212);
    plotB.reshape(182,281+MenuBarHeight,96,25);
    helpB.reshape(182,337+MenuBarHeight,75,25);
    clearB.reshape(19,295+MenuBarHeight,106,25);
    resetB.reshape(77,360+MenuBarHeight,75,25);
    // End of InitialPositionSet()
  }
  
  public boolean handleEvent(Event evt)
  {
    // handleEvent()
    if (evt.id == Event.WINDOW_DESTROY && evt.target == this) L_WindowDestroy(evt.target);
    else if (evt.id == Event.ACTION_EVENT && evt.target == helpB) help(evt.target);
    else if (evt.id == Event.ACTION_EVENT && evt.target == input) getInstruction(evt.target);
    else if (evt.id == Event.ACTION_EVENT && evt.target == clearB) clear(evt.target);
    else if (evt.id == Event.ACTION_EVENT && evt.target == plotB) plot(evt.target);
    else if (evt.id == Event.ACTION_EVENT && evt.target == resetB) reset(evt.target);
    // End of handleEvent()
    
    return super.handleEvent(evt);
  }
  
  // Event Handling Routines
  public void L_WindowDestroy(Object target)
  {
    System.exit(0);
  }
  
  public void help(Object target)
  {
    output.appendText("Format:\n"+
                      "A + space + number + enter\n"+
                      "R + space + numberOfRecursionsForF + enter\n"+
                      "X + space + axiom + enter\n"+
                      "letter + equal + F's,+'s,-'s + enter\n"+
                      "Be careful of extra spaces and caps.\n"
                      );
  }
  
  public void getInstruction(Object target)
  {
    String s=input.getText();
    if(s.startsWith("A ")){
      try{
        a=Float.valueOf(s.substring(2)).floatValue();
        output.appendText("New turn angle = "+String.valueOf(a)+"\n");
      }catch(NumberFormatException e){
        output.appendText("Please try again using numerable numbers\n");
      }
    }else
    if(s.startsWith("R ")){
      try{
        r=Integer.valueOf(s.substring(2)).intValue();
        output.appendText("Number of recursions = "+String.valueOf(r)+"\n");
      }catch(NumberFormatException e){
        output.appendText("Please try again using numerable integers\n");
      }
    }else
    if(s.startsWith("X ")){
      axiom=s.substring(2);
        output.appendText("New axiom = "+axiom+"\n");
    }else
    if(s.startsWith("=",1)){
    boolean novaia=true;
    int pos=0;
    for (int i=0;i<rules.size();i++){
      String tmp=(String)rules.elementAt(i);
      if (tmp.substring(0,2).compareTo(input.getText().substring(0,2))==0){
        novaia=false;
        pos=i;
      }
    }
    if (!novaia){
      output.appendText("Production rule replaced\n");
      rules.removeElementAt(pos);
    }
    rules.addElement(input.getText());
    if(novaia)
      output.appendText("Production rule added\n");
    }else{
      output.appendText("Error in input\n");    
    }
    input.setText("");
  }

  public void clear(Object target)
  {
    output.setText("");  
  }

  public void addpoint(float alfa){
    //double th=Math.toRadians(alfa);
    double th=Math.PI*alfa/180;
    float xn=(float)(xa+l*Math.cos(th));
    float yn=(float)(ya-l*Math.sin(th));
    Points pnts= new Points (xa,ya,xn,yn);
    points.addElement(pnts);
    if (xn>xmax)xmax=xn;
    if (yn>ymax)ymax=yn;
    if (xn<xmin)xmin=xn;
    if (yn<ymin)ymin=yn;
    xa=xn;
    ya=yn;
  }

  public void produce(String str, int rec, float alfa){
    int i,j;
    String tmp;
    for (i=0;i<str.length();i++){
      if ((str.substring(i,i+1).compareTo("F")==0)&&(rec<=0)){
        addpoint(alfa);
      } else
      if (str.substring(i,i+1).compareTo("+")==0){
        alfa+=a;
      } else
      if (str.substring(i,i+1).compareTo("-")==0){
        alfa-=a;
      } else{
        for (j=0;j<rules.size();j++){
          tmp=(String)rules.elementAt(j);
          if (tmp.substring(0,1).compareTo(str.substring(i,i+1))==0){
            if (tmp.substring(0,1).compareTo("F")==0)
              produce(tmp.substring(2,tmp.length()),rec-1,alfa);
            else
              produce(tmp.substring(2,tmp.length()),rec,alfa);
          }
        }
      }
    }
  }
  
  public void plot(Object target)
  {
    points=new Vector ((int)20,(int)3);
    alfa=0;
    xa=0;ya=0;
    xmin=xa;xmax=xa+(float)0.0001;ymin=ya;ymax=ya+(float)0.0001;
    produce (axiom,r,alfa);
    repaint();
    output.appendText("Axiom plotted\n");
  }

  public void reset(Object target)
  {
    axiom="";
    a=60;
    r=0;
    rules.removeAllElements();      
    points.removeAllElements();  
    repaint();    
  }

  // End of Event Handling Routines
  
} // End of Class L