//Carlos Gershenson
//carlos@jlagunez.iquimica.unam.mx

import java.util.*;
import Rule;

public class Parser {
  Stack ss;//syntactic stack
  int es;//entry symbol
  int step;//step number
  int rule;//rule number reduced by
  boolean error;
  public Parser() {
    ss = new Stack();
    es = 0;
    step = 0;
    error = false;
  }
  
  void showstack(Stack s) {//print given stack s
    for (int i = 0;i < s.size();i++)
      System.out.print(s.elementAt(i)+" ");
  }
  
  boolean reduce() {//substitute for precedence automata
                    //reduces semantic stack as much as possible by rules
                    //returns false if there's no rule that can reduce the sem. stack at any point
    int i,j,rulenum;
    Stack stmp;
    for (i = 0;i < ss.size();i++) {
      stmp = new Stack();
      for (j = i;j < ss.size();j++) {
        stmp.addElement(ss.elementAt(j));
      }
      //showstack(stmp);
      //System.out.println();
      rulenum = reduceable(stmp);
      if (rulenum >= 0) {
        rule = rulenum;
        Rule rule = (Rule)C.P.elementAt(rulenum);
        for(j = 0;j < rule.t.size();j++) {
          ss.pop();
        }
        ss.push(new Integer(rule.i));
        return true;
      }
    }
    return false;
  }
  
  int reduceable(Stack s) {//returns the rule number by which a stack is reduceable
                           //returns -1 if there's no such rule
    int i,j;
    Integer stacki,rulei;
    boolean ok=false;
    for(i = 0;i < C.sizeP;i++) {
      Rule rule = (Rule)C.P.elementAt(i);
      if (rule.t.size() == s.size()) {
        ok = true;
        for(j = 0;j < rule.t.size();j++) {
          rulei = (Integer)rule.t.elementAt(j);
          stacki = (Integer)s.elementAt(j);
          if(rulei.intValue() != stacki.intValue())
            ok = false;
        }
      }
      if (ok) return i;
    }
    return -1;
  }
  
  int M(int u, int v) {//substitute function of the precendence automata
                       //returns 0 if there's an error, 1 if the Parser should continue reading
                       //and 2 if it should reduce
                       //This is where C.parts are used
    int i,j;
    Integer up,vp;
    for(i = 0;i < C.sizeP;i++) {
      Rule rule = (Rule)C.P.elementAt(i);
      for(j = 0;j < rule.t.size()-1;j++) {
        up = (Integer)rule.t.elementAt(j);
        //System.out.print(up);
        vp = (Integer)rule.t.elementAt(j+1);
        //System.out.print(vp);
        if(up.intValue() == u) {
          try{
          //if(vp.intValue()-C.sizeT-1>=0)
            if ((vp.intValue() == v)||(C.parts[vp.intValue()-C.sizeT-1].pi.contains(new Integer(v))))
              return 1;//continue reading
          }catch(ArrayIndexOutOfBoundsException e){}
          }
          if (vp.intValue() == v) {
          if(up.intValue()-C.sizeT-1 >= 0)
            if(C.parts[up.intValue()-C.sizeT-1].pd.contains(new Integer(u)))
              return 2;//reduce
          }
          if((up.intValue()-C.sizeT-1 >= 0)&&(vp.intValue()-C.sizeT-1 >= 0))
            if((C.parts[up.intValue()-C.sizeT-1].pd.contains(new Integer(u)))&&(C.parts[vp.intValue()-C.sizeT-1].pi.contains(/*up*/new Integer(v))))
              return 2;//reduce
          }
        }
        return 0;
    }
    
    
  }