// {$R PostMachine.JFM}
import java.awt.*;
import java.applet.Applet;
import java.util.*;
import java.io.*;

class Tape {
  public Vector t = new Vector((int)1000,(int)3);//tape
  public int head;//position of the head
  public Tape() {
    int i;
    head = 0;
    for(i = 0;i < t.capacity();i++) {
      t.insertElementAt(new Boolean(false),i);
    }
  }
  public int toTapePos(int n) {
    if (n >= 0)
      return 2*n;
    else
      return ((-2*n)-1);
  }
  public String print() {
    String s = new String(),s1 = new String(),s2 = new String();
    int i;
    Boolean cell;
    for (i = 0;i < (25+(head % 10));i++)
    s1+= " ";
    for (i = 0;i < (24-(head % 10));i++)
    s2+= " ";
    for (i = (10*(head / 10))-25;i <= (10*(head / 10))+25;i++) {
      try {
        cell = (Boolean)t.elementAt(toTapePos(i));
      } catch(ArrayIndexOutOfBoundsException e) {
        grow();
        cell = new Boolean(false);
      }
      if (cell.booleanValue())
        s+= "*";
      else
        s+= ".";
    }
    s+= "\n"+s1+"^"+s2+String.valueOf(i-1)+"\n";
    return s;
  }
  public void grow() {
    int i;
    int cap = t.capacity();
    t.ensureCapacity(cap+10);
    for(i = cap;i < t.size();i++) {
      t.setElementAt(new Boolean(false),i);
    }
  }
}

class Name {
  public String s;//string
  public int n;//number of instruction
}

class InstructionStr {
  public String s1,s2,s3;//parameters
  char op;//operator
  public String print() {
    String s = new String();
    s = s1+". "+this.op+" "+s2+" "+s3+"\n";
    return s;
  }
}

class Instruction {
  public int p1,p2,p3;//parameters
  char op;//operator
  public String print() {
    String s = new String();
    s = String.valueOf(this.p1)+". "+this.op+" "+String.valueOf(this.p2)+" "+String.valueOf(this.p3)+"\n";
    return s;
  }
}

// Class PostMachine
public class PostMachine extends Applet implements Runnable
{
  Vector names = new Vector((int)200,(int)3);//vector of names
  Vector symbols = new Vector((int)6,(int)1);//vector of symbols
  Vector program = new Vector((int)200,(int)3);//vector of number instructions
  Vector programStr = new Vector((int)200,(int)3);//vector of string instructions
  Tape t = new Tape();
  int stepN;//number of step
  int nextInst;//next instruction of the program
  boolean stop;//flag for stopping execution of program
  Thread runTh = null;
  
  final int MenuBarHeight = 0;
  
  // Component Declaration
  public Button loadProgram;
  public Button reset;
  public Button help;
  public Label firstPosition;
  public TextField fPos;
  public Label tapeIni;
  public TextField iniTape;
  public Button stepButt;
  public Button runButt;
  public TextArea output;
  public Button clear;
  public TextField fileName;
  public Button stopButt;
  public Image Image1;
  // End of Component Declaration
  
  // init()
  public void init()
  {
    symbols.addElement(">");//right
    symbols.addElement("<");//left
    symbols.addElement("*");//mark
    symbols.addElement("0");//unmark
    symbols.addElement("?");//jump
    symbols.addElement("|");//stop
    stop = true;
    
    // Frame Initialization
    setForeground(Color.black);
    setBackground(Color.white);
    setFont(new Font("Dialog",Font.BOLD,12));
    setLayout(null);
    // End of Frame Initialization
    
    // Component Initialization
    loadProgram = new Button("Load Program");
    loadProgram.setFont(new Font("Dialog",Font.BOLD,12));
    reset = new Button("Reset");
    reset.setFont(new Font("Dialog",Font.BOLD,12));
    help = new Button("Help");
    help.setFont(new Font("Dialog",Font.BOLD,12));
    firstPosition = new Label("First position:",Label.LEFT);
    firstPosition.setFont(new Font("Dialog",Font.BOLD,12));
    fPos = new TextField("0");
    fPos.setForeground(Color.black);
    fPos.setBackground(Color.white);
    fPos.setFont(new Font("Dialog",Font.BOLD,12));
    tapeIni = new Label("Tape:",Label.LEFT);
    tapeIni.setFont(new Font("Dialog",Font.BOLD,12));
    iniTape = new TextField("***.*****");
    iniTape.setForeground(Color.black);
    iniTape.setBackground(Color.white);
    iniTape.setFont(new Font("Courier",Font.BOLD,12));
    stepButt = new Button("Step");
    stepButt.setFont(new Font("Dialog",Font.BOLD,12));
    runButt = new Button("Run");
    runButt.setFont(new Font("Dialog",Font.BOLD,12));
    output = new TextArea("Welcome to post machine. Copyright Gershenson Technologies 1999\n");
    output.setForeground(Color.black);
    output.setBackground(Color.white);
    output.setFont(new Font("Courier",Font.BOLD,10));
    clear = new Button("Clear");
    clear.setFont(new Font("Dialog",Font.BOLD,12));
    fileName = new TextField("primer.txt");
    fileName.setForeground(Color.black);
    fileName.setBackground(Color.white);
    fileName.setFont(new Font("Dialog",Font.BOLD,12));
    stopButt = new Button("Stop");
    stopButt.setFont(new Font("Dialog",Font.BOLD,12));
    Image1 = getImage(getCodeBase(), "Eye.gif");
    // End of Component Initialization
    
    // Add()s
    add(stopButt);
    add(fileName);
    add(clear);
    add(output);
    add(runButt);
    add(stepButt);
    add(iniTape);
    add(tapeIni);
    add(fPos);
    add(firstPosition);
    add(help);
    add(reset);
    add(loadProgram);
    // End of Add()s
    
    InitialPositionSet();
  } // End of init()
  
  // start()
  public void start()
  {
  } // End of start()
  
  // stop()
  public void stop()
  {
    runTh.stop();//stop thread
  } // End of stop()
  
  // destroy()
  public void destroy()
  {
  } // End of destroy()
  
  public void paint(Graphics g)
  {
    // paint()
    g.drawImage(Image1, 428,113,30,33, this);
    // End of paint()
  }
  
  public void InitialPositionSet()
  {
    // InitialPositionSet()
    resize(474,372);
    loadProgram.reshape(144,9+MenuBarHeight,117,25);
    reset.reshape(278,9+MenuBarHeight,75,25);
    help.reshape(389,10+MenuBarHeight,75,25);
    firstPosition.reshape(13,69+MenuBarHeight,114,19);
    fPos.reshape(127,64+MenuBarHeight,37,27);
    tapeIni.reshape(204,69+MenuBarHeight,51,19);
    iniTape.reshape(257,63+MenuBarHeight,203,24);
    stepButt.reshape(10,120+MenuBarHeight,75,25);
    runButt.reshape(99,119+MenuBarHeight,75,25);
    output.reshape(8,159+MenuBarHeight,450,202);
    clear.reshape(312,118+MenuBarHeight,75,25);
    fileName.reshape(11,9+MenuBarHeight,121,27);
    stopButt.reshape(186,119+MenuBarHeight,75,25);
    // End of InitialPositionSet()
  }
  
  public boolean handleEvent(Event evt)
  {
    // handleEvent()
    if (evt.id == Event.WINDOW_DESTROY && evt.target == this) PostMachine_WindowDestroy(evt.target);
    else if (evt.id == Event.ACTION_EVENT && evt.target == loadProgram) load(evt.target);
    else if (evt.id == Event.ACTION_EVENT && evt.target == clear) clearOutput(evt.target);
    else if (evt.id == Event.ACTION_EVENT && evt.target == help) help(evt.target);
    else if (evt.id == Event.ACTION_EVENT && evt.target == reset) reset(evt.target);
    else if (evt.id == Event.ACTION_EVENT && evt.target == runButt) run(evt.target);
    else if (evt.id == Event.ACTION_EVENT && evt.target == stepButt) step(evt.target);
    else if (evt.id == Event.ACTION_EVENT && evt.target == stopButt) stop(evt.target);
    // End of handleEvent()
    
    return super.handleEvent(evt);
  }
  
  // Event Handling Routines
  public void PostMachine_WindowDestroy(Object target)
  {
    System.exit(0);
  }
  
  public void load(Object target) {
    int i,line = 0;
    char ch,op;
    InstructionStr inststr;
    Instruction inst;
    Name nam;
    String str1 = new String(),str2 = new String(),str3 = new String();
    String fileN = new String(fileName.getText());
    names.removeAllElements();
    program.removeAllElements();
    programStr.removeAllElements();
    reset(target);
    try
    {
      RandomAccessFile file = new RandomAccessFile(fileN, "r");
      long filePointer = 0;
      long length = file.length();
      output.appendText(file.readLine()+"\n");
      while (filePointer < length)
      {
        String s = file.readLine();
        s+= "\n";
        line++;
        i = 0;
        inststr = new InstructionStr();
        while(i < s.length()) {
          ch = s.charAt(i);
          i++;
          str1 = new String();
          str2 = new String();
          str3 = new String();
          while((Character.isSpace(ch))&&(i < s.length())) {
            ch = s.charAt(i);
            i++; 
          }
          while(( ! (Character.isSpace(ch)))&&(ch != ';')&&(i < s.length())&&( ! symbols.contains(String.valueOf(ch)))) {
            str1+= String.valueOf(ch);
            ch = s.charAt(i);
            i++;
          }
          while((Character.isSpace(ch))&&(i < s.length())) {
            ch = s.charAt(i);
            i++; 
          }
          op = ch; 
          ch = s.charAt(i);
          i++; 
          while((Character.isSpace(ch))&&(i < s.length())) {
            ch = s.charAt(i);
            i++; 
          }
          while(( ! (Character.isSpace(ch)))&&(ch != ';')&&(i < s.length())&&( ! symbols.contains(String.valueOf(ch)))) {
            str2+= String.valueOf(ch);
            ch = s.charAt(i);
            i++;
          }
          while((Character.isSpace(ch))&&(i < s.length())) {
            ch = s.charAt(i);
            i++; 
          }
          while(( ! (Character.isSpace(ch)))&&(ch != ';')&&(i < s.length())&&( ! symbols.contains(String.valueOf(ch)))) {
            str3+= String.valueOf(ch);
            ch = s.charAt(i);
            i++;
          }
          i = s.length()+1;
          //output.appendText("s1 "+str1+"\nop "+op+"\ns2 "+str2+"\ns3 "+str3+"\n\n");
          inststr.s1 = str1;
          inststr.op = op;
          inststr.s2 = str2;
          inststr.s3 = str3;
          output.appendText(inststr.print());
          programStr.addElement(inststr);
          
        }
        filePointer = file.getFilePointer();
        //output.appendText(s+", "+String.valueOf(filePointer)+"\n");
      }
      
      for(i = 0;i < programStr.size();i++) {
        inststr = (InstructionStr)programStr.elementAt(i);
        if ( ! inststr.s1.equals("")) {
          nam = new Name();
          nam.n = i+1;
          nam.s = inststr.s1;
          //output.appendText(nam.s+"\n");
          names.addElement(nam);
        }
      }
      for(i = 0;i < programStr.size();i++) {
        inststr = (InstructionStr)programStr.elementAt(i);
        inst = new Instruction();
        inst.p1 = findNum(inststr.s1,1,i);
        inst.op = inststr.op;
        inst.p2 = findNum(inststr.s2,2,i);
        inst.p3 = findNum(inststr.s3,3,i);
        output.appendText(inst.print());
        program.addElement(inst);
      }
    }
    catch (Exception e)
    {
      String err = e.toString();
      output.appendText(err+"\n");
    }
    
  }
  
  public void clearOutput(Object target)
  {
    output.setText("");
  }
  
  public void help(Object target)
  {
    output.appendText("This shareware version of Post Machine doesnt include Help\n");
    output.appendText("If you want to recieve a Complete version, send $60 USD to us\n");
    output.appendText("Thanks for using Post Machine\n");
  }
  
  public void reset(Object target)
  {
    stepN = 0;
    stop = false;
    t = new Tape();
    t.head = 0;
  }
  
  public void run(Object target)
  {
    runTh = new Thread(this, "Simulation"); 
    runTh.start();
  }
  
  public void step(Object target)
  {
    if ( ! stop) {
      Instruction inst;
      Boolean cell;
      stepN++;
      if (stepN <= 1) {
        nextInst = 1;
        loadTape();
        output.appendText("Initial conditions of Tape:\n"+t.print()+"\n");
      }
      inst = (Instruction) program.elementAt(nextInst-1);
      switch(inst.op) {
        case '>': {
          t.head++;
          nextInst = inst.p2;
        } break;
        case '<': {
          t.head--;
          nextInst = inst.p2;
        } break;
        case '*': {
          try {
            cell = (Boolean)t.t.elementAt(t.toTapePos(t.head));
          } catch(ArrayIndexOutOfBoundsException e) {
            t.grow();
            cell = new Boolean(false);
          }
          if (cell.booleanValue()) {
            stop = true;
            output.appendText("Stop without results :(\n");
          } else {
            try {
              t.t.setElementAt(new Boolean(true),t.toTapePos(t.head));
            } catch(ArrayIndexOutOfBoundsException e) {
              t.grow();
              t.t.setElementAt(new Boolean(true),t.toTapePos(t.head));
            }
          } 
          nextInst = inst.p2;
        } break;
        case '0': {
          try {
            cell = (Boolean)t.t.elementAt(t.toTapePos(t.head));
          } catch(ArrayIndexOutOfBoundsException e) {
            t.grow();
            cell = new Boolean(false);
          }
          if (cell.booleanValue()) {
            try {
              t.t.setElementAt(new Boolean(false),t.toTapePos(t.head));
            } catch(ArrayIndexOutOfBoundsException e) {
              t.grow();
              t.t.setElementAt(new Boolean(false),t.toTapePos(t.head));
            }
          } else {
            stop = true;
            output.appendText("Stop without results :(\n");
          } 
          nextInst = inst.p2;
        } break;
        case '|': {
          stop = true;
          output.appendText("Stop with results :)\n");
          nextInst = inst.p1;
        } break;
        case '?': {
          try {
            cell = (Boolean)t.t.elementAt(t.toTapePos(t.head));
          } catch(ArrayIndexOutOfBoundsException e) {
            t.grow();
            cell = new Boolean(false);
          }
          if (cell.booleanValue())
            nextInst = inst.p3;
          else
            nextInst = inst.p2;
        } break;
        default: {
          output.appendText("There was an error in the program\n");
        } break;
      }
      output.appendText("Step: "+String.valueOf(stepN)+":   "+inst.print()+t.print()+"\n");
    }
  }
  
  public void stop(Object target)
  {
    runTh = null;//stop thread
    stop = true;
  } 
  
  // End of Event Handling Routines
  
  
  public int findNum(String s, int param, int line) {
    Name old = new Name();
    InstructionStr inststr = (InstructionStr) programStr.elementAt(line);
    int i;
    line++;
    if ((param > 2)&&(inststr.op != '?'))
      return 0;
    if (param > 1)
      line++;
    for(i = 0;i < names.size();i++) {
      old = (Name) names.elementAt(i);
      if (old.s.equals(s)) {
        //output.appendText("old "+old.s+" n: "+String.valueOf(old.n)+"\n");
        return old.n;
      }
    }
    //output.appendText("line "+String.valueOf(line)+"\n");
    return line;
  }
  
  public void loadTape() {
    t = new Tape();
    t.head = 0;
    String s = new String(iniTape.getText());
    int first = 0,i;
    try {
      first = Integer.valueOf(fPos.getText()).intValue();
    }
    catch (NumberFormatException e) {
      output.appendText("Please fill the fileds correctly!\n");
    }
    for(i = 0;i < s.length();i++) {
      if (s.charAt(i) == '*') {
        try {
          t.t.setElementAt(new Boolean(true),t.toTapePos(i+first));
        } catch(ArrayIndexOutOfBoundsException e) {
          t.grow();
          t.t.setElementAt(new Boolean(true),t.toTapePos(i+first));
        }
      } else {
        try {
          t.t.setElementAt(new Boolean(false),t.toTapePos(i+first));
        } catch(ArrayIndexOutOfBoundsException e) {
          t.grow();
          t.t.setElementAt(new Boolean(false),t.toTapePos(i+first));
        }
      }
    }
  }
  
  
  public void run() {
    Thread myThread = Thread.currentThread();
    while (( ! stop)&&(runTh == myThread)) {
      step(new Object());
    }
  }
  
} // End of Class PostMachine