// {$R PostMachine.JFM}

import java.awt.*;
import java.applet.Applet;
import java.util.*;
import java.io.*;

class Name{
    public String s;//string
    public int n;//number of instruction
}


// Class PostMachine
public class PostMachine extends Applet
{
    Vector names = new Vector((int)20,(int)3);//vector of names
    Vector symbols = new Vector((int)6,(int)1);//vector of symbols
    
    final int MenuBarHeight = 0;

    // Component Declaration
    public Button loadProgram;
    public Button reset;
    public Button help;
    public Label firstPosition;
    public TextField hPos;
    public Label tapeIni;
    public TextField iniTape;
    public Button step;
    public Button run;
    public TextArea output;
    public Button clear;
    public TextField fileName;
    // End of Component Declaration

    // init()
    public void init()
    {
        symbols.addElement(">");//right
        symbols.addElement("<");//left
        symbols.addElement("*");//mark
        symbols.addElement("0");//unmark
        symbols.addElement("?");//jump
        symbols.addElement("|");//stop
        
        
        // Frame Initialization
        setForeground(Color.black);
        setBackground(Color.white);
        setFont(new Font("Dialog",Font.BOLD,12));
        setLayout(null);
        // End of Frame Initialization

        // Component Initialization
        loadProgram = new Button("Load Program");
        loadProgram.setFont(new Font("Dialog",Font.BOLD,12));
        reset = new Button("Reset");
        reset.setFont(new Font("Dialog",Font.BOLD,12));
        help = new Button("Help");
        help.setFont(new Font("Dialog",Font.BOLD,12));
        firstPosition = new Label("First position:",Label.LEFT);
        firstPosition.setFont(new Font("Dialog",Font.BOLD,12));
        hPos = new TextField("0");
        hPos.setForeground(Color.black);
        hPos.setBackground(Color.white);
        hPos.setFont(new Font("Dialog",Font.BOLD,12));
        tapeIni = new Label("Tape:",Label.LEFT);
        tapeIni.setFont(new Font("Dialog",Font.BOLD,12));
        iniTape = new TextField("....*..");
        iniTape.setForeground(Color.black);
        iniTape.setBackground(Color.white);
        iniTape.setFont(new Font("Courier",Font.BOLD,12));
        step = new Button("Step");
        step.setFont(new Font("Dialog",Font.BOLD,12));
        run = new Button("Run");
        run.setFont(new Font("Dialog",Font.BOLD,12));
        output = new TextArea("Welcome to post machine. Copyright Gershenson Technologies 1999\n");
        output.setForeground(Color.black);
        output.setBackground(Color.white);
        output.setFont(new Font("Courier",Font.BOLD,10));
        clear = new Button("Clear");
        clear.setFont(new Font("Dialog",Font.BOLD,12));
        fileName = new TextField("pato.txt");
        fileName.setForeground(Color.black);
        fileName.setBackground(Color.white);
        fileName.setFont(new Font("Dialog",Font.BOLD,12));
        // End of Component Initialization

        // Add()s
        add(fileName);
        add(clear);
        add(output);
        add(run);
        add(step);
        add(iniTape);
        add(tapeIni);
        add(hPos);
        add(firstPosition);
        add(help);
        add(reset);
        add(loadProgram);
        // End of Add()s

        InitialPositionSet();
    } // End of init()

    // start()
    public void start()
    {
    } // End of start()

    // stop()
    public void stop()
    {
    } // End of stop()

    // destroy()
    public void destroy()
    {
    } // End of destroy()

    public void paint(Graphics g)
    {
        // paint()
        // End of paint()
    }

    public void InitialPositionSet()
    {
        // InitialPositionSet()
        resize(566,370);
        loadProgram.reshape(144,9+MenuBarHeight,117,25);
        reset.reshape(278,9+MenuBarHeight,75,25);
        help.reshape(388,8+MenuBarHeight,75,25);
        firstPosition.reshape(13,69+MenuBarHeight,114,19);
        hPos.reshape(128,64+MenuBarHeight,29,27);
        tapeIni.reshape(169,68+MenuBarHeight,51,19);
        iniTape.reshape(224,64+MenuBarHeight,168,24);
        step.reshape(10,120+MenuBarHeight,75,25);
        run.reshape(111,120+MenuBarHeight,75,25);
        output.reshape(9,173+MenuBarHeight,381,188);
        clear.reshape(307,118+MenuBarHeight,75,25);
        fileName.reshape(11,9+MenuBarHeight,121,27);
        // End of InitialPositionSet()
    }

    public boolean handleEvent(Event evt)
    {
        // handleEvent()
        if (evt.id == Event.WINDOW_DESTROY && evt.target == this) PostMachine_WindowDestroy(evt.target);
        else if (evt.id == Event.ACTION_EVENT && evt.target == loadProgram) load(evt.target);
        else if (evt.id == Event.ACTION_EVENT && evt.target == clear) clearOutput(evt.target);
        // End of handleEvent()

        return super.handleEvent(evt);
    }

    // Event Handling Routines
    public void PostMachine_WindowDestroy(Object target)
    {
        System.exit(0);
    }

    public void load(Object target)
    {
      int i,line;
      boolean eol;
      char ch,op;
      String str1=new String(),str2=new String(),str3=new String();
      String fileN=new String(fileName.getText());
      try
        {
            RandomAccessFile file =new RandomAccessFile(fileN, "r");
            long filePointer = 0;
            long length = file.length();
            while (filePointer < length)
            {
                String s = file.readLine();
                s+="\n";
                line=0;
                i=0;
                while(i<s.length()){
                  /*if(symbols.contains('*')output.appendText("jala\n");
                  else output.appendText("no jala\n");
                  */line++;
                  eol=false;
                  ch=s.charAt(i);
                  i++;
                  str1=new String();
                  str2=new String();
                  str3=new String();
                  while((Character.isSpace(ch))&&(i<s.length())){
                    ch=s.charAt(i);
                    i++;                  
                  }
                  while((!(Character.isSpace(ch)))&&(ch!=';')&&(i<s.length())&&(!symbols.contains(String.valueOf(ch)))){
                    str1+=String.valueOf(ch);
                    ch=s.charAt(i);
                    i++;
                  }
                  while((Character.isSpace(ch))&&(i<s.length())){
                    ch=s.charAt(i);
                    i++;                  
                  }
                  op=ch;     
                  ch=s.charAt(i);
                  i++;                  
                  while((Character.isSpace(ch))&&(i<s.length())){
                    ch=s.charAt(i);
                    i++;                  
                  }
                  while((!(Character.isSpace(ch)))&&(ch!=';')&&(i<s.length())&&(!symbols.contains(String.valueOf(ch)))){
                    str2+=String.valueOf(ch);
                    ch=s.charAt(i);
                    i++;
                  }
                  while((Character.isSpace(ch))&&(i<s.length())){
                    ch=s.charAt(i);
                    i++;                  
                  }
                  while((!(Character.isSpace(ch)))&&(ch!=';')&&(i<s.length())&&(!symbols.contains(String.valueOf(ch)))){
                    str3+=String.valueOf(ch);
                    ch=s.charAt(i);
                    i++;
                  }
                  i=s.length()+1;
                  output.appendText("s1 "+str1+"\nop "+op+"\ns2 "+str2+"\ns3 "+str3+"\n\n");
                  //output.appendText(String.valueOf(ch));
                                  }
                filePointer = file.getFilePointer();
                //output.appendText(s+", "+String.valueOf(filePointer)+"\n");
            }
        }
        catch (Exception e)
        {
            String err = e.toString();
            output.appendText(err+"\n");
        }
        
    }

    public void clearOutput(Object target)
    {
      output.setText("");
    }

    // End of Event Handling Routines

} // End of Class PostMachine