//Carlos Gershenson
//carlos@jlagunez.iquimica.unam.mx

import java.util.*;

public class Scanner {
  StringTokenizer st;
  double number;//value of last number read
  String var;//name of last var read
  boolean error;
  public Scanner(String code) {
    st = new StringTokenizer(code,C.TOKENS,true);//turn code into a StringTokenizer with tokens as separators
    error = false;
  }
  
  public int getToken() {//returns value from the tokens Hashtable of token read
                         //substitute of recognition automata
    Integer ret;
    String s = " ";
    while (s.compareTo(" ") == 0) {
      try{
        s = st.nextToken();
      }catch (NoSuchElementException e){
        return 0;
      }
    }
    if ((s.compareTo("!") == 0)||(s.compareTo("<") == 0)||(s.compareTo(">") == 0)) {
      //check for composed tokens like <= or >=
      String s3 =st.nextToken();
      String s2 = s+s3;
      if ((s2.compareTo("!=") == 0)||(s2.compareTo("<=") == 0)||(s2.compareTo(">=") == 0)) {//token was <= or >= or !=
        ret = (Integer)C.tokens.get(s2);
        return ret.intValue();
      } else {//restore st
        while (st.hasMoreTokens()) {
          s3+= st.nextToken();
        }
        st = new StringTokenizer(s3,C.TOKENS,true);
      }
    }
    if (C.tokens.get(s) != null) {//token recognized in hashtable
      ret = (Integer)C.tokens.get(s);
      return ret.intValue();
    }
    boolean ok=true;
    double prov =-1;
    try {//check if token is number
      prov = Double.valueOf(s).doubleValue();
    }catch (NumberFormatException e) {
      ok = false;
    }
    if (ok) {//token is a number
      number=prov;
      return 1;
    }else{//check if token is a variable
      if (Character.isLetter(s.charAt(0))){
        ok =true;
        for (int i=0;i<s.length();i++){
          //if(!((Character.isLetter(s.charAt(i)))||(Character.isDigit(s.charAt(i)))||(s.charAt(i)=='_')))
          if(!(Character.isJavaLetterOrDigit(s.charAt(i))))
            ok=false;
        }
        if(ok){//token is a valid variable name
          var=s;
          return 2;
        }
      }
    }
    error = true;
    return -1;
  }
  
  public boolean moreTokens() {//returns true if theres more code to compile
    return st.hasMoreTokens();
  }
  
}