//Carlos Gershenson
//carlos@jlagunez.iquimica.unam.mx

import java.util.*;
import java.io.*; 

public class X {//virtual machine, to read code generated by C
  Stack s;
  StringTokenizer st;
  Hashtable varsvals,iset;//values of variables and instruction set
  int numvars = 0;//number of vars
  int pc = 0;//program counter
  String str;
  public X(String code) {
    Double num = null,num2 = null;
    BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    st = new StringTokenizer(code);//StringTokenizer with code to be executed
    s = new Stack();
    varsvals = new Hashtable();
    iset = new Hashtable();//generate instruction set
    iset.put("END",new Integer(0));
    iset.put("WRITE",new Integer(1));
    iset.put("PushVAL",new Integer(2));
    iset.put("PushVAR",new Integer(3));
    iset.put("NEG",new Integer(4));
    iset.put("AND",new Integer(5));
    iset.put("OR",new Integer(6));
    iset.put("LESS",new Integer(7));
    iset.put("GREAT",new Integer(8));
    iset.put("LESST",new Integer(9));
    iset.put("GREATT",new Integer(10));
    iset.put("EQ",new Integer(11));
    iset.put("NEQ",new Integer(12));
    iset.put("PLUS",new Integer(13));
    iset.put("MINUS",new Integer(14));
    iset.put("MUL",new Integer(15));
    iset.put("DIV",new Integer(16));
    iset.put("POT",new Integer(17));
    iset.put("SIN",new Integer(18));
    iset.put("COS",new Integer(19));
    iset.put("TAN",new Integer(20));
    str = st.nextToken();
    numvars = Integer.valueOf(str).intValue();
    for (int i = 0;i < numvars;i++) {//get values of variables
      System.out.println("Please give me the value of variable "+C.vvars.elementAt(i));
      boolean error = true;
      while (error) {
        String val = "";
        try {
          val = br.readLine();
          num = Double.valueOf(val);
          error = false;
        } catch(NumberFormatException e) {
          System.out.println("Try again... ");
          error = true;
        } catch(IOException e) { }
      }
      varsvals.put(new Integer(i+1),num);
    }
    while(str.compareTo("END") != 0) {//run program
      str = st.nextToken();//get next instruction from code
      pc++;
      Integer ins = (Integer) iset.get(str);
      switch (ins.intValue()) {//execute instruction
        case 1:
          num = (Double)s.pop();
          System.out.println("Result: "+num);
        break;
        case 2:
          str = st.nextToken();
          try {
            num = Double.valueOf(str);
          } catch(NumberFormatException e) { }
          s.push(num);
        break;
        case 3:
          str = st.nextToken();
          Integer num3 = null;
          try {
            num3 = Integer.valueOf(str);
          } catch(NumberFormatException e) { }
          s.push(varsvals.get(num3));
        break;
        case 4:
          num = (Double)s.pop();
          s.push(new Double(-1*num.doubleValue()));
        break;
        case 5:
          num = (Double)s.pop();
          num2 = (Double)s.pop();
          if (dtbool(num)&&dtbool(num2))
            s.push(new Double (1));
          else
            s.push(new Double (0));
        break;
        case 6:
          num = (Double)s.pop();
          num2 = (Double)s.pop();
          if (dtbool(num)||dtbool(num2))
            s.push(new Double (1));
          else
            s.push(new Double (0));
        break;
        case 7:
          num = (Double)s.pop();
          num2 = (Double)s.pop();
          if (num2.doubleValue()<num.doubleValue())
            s.push(new Double (1));
          else
            s.push(new Double (0));
        break;
        case 8:
          num = (Double)s.pop();
          num2 = (Double)s.pop();
          if (num2.doubleValue()>num.doubleValue())
            s.push(new Double (1));
          else
            s.push(new Double (0));
        break;
        case 9:
          num = (Double)s.pop();
          num2 = (Double)s.pop();
          if (num2.doubleValue()<=num.doubleValue())
            s.push(new Double (1));
          else
            s.push(new Double (0));
        break;
        case 10:
          num = (Double)s.pop();
          num2 = (Double)s.pop();
          if (num2.doubleValue()>=num.doubleValue())
            s.push(new Double (1));
          else
            s.push(new Double (0));
        break;
        case 11:
          num = (Double)s.pop();
          num2 = (Double)s.pop();
          if (num.doubleValue()==num2.doubleValue())
            s.push(new Double (1));
          else
            s.push(new Double (0));
        break;
        case 12:
          num = (Double)s.pop();
          num2 = (Double)s.pop();
          if (num.doubleValue()!=num2.doubleValue())
            s.push(new Double (1));
          else
            s.push(new Double (0));
        break;
        case 13:
          num = (Double)s.pop();
          num2 = (Double)s.pop();
          s.push(new Double (num.doubleValue()+num2.doubleValue()));
        break;
        case 14:
          num = (Double)s.pop();
          num2 = (Double)s.pop();
          s.push(new Double (num2.doubleValue()-num.doubleValue()));
        break;
        case 15:
          num = (Double)s.pop();
          num2 = (Double)s.pop();
          s.push(new Double (num.doubleValue()*num2.doubleValue()));
        break;
        case 16:
          num = (Double)s.pop();
          num2 = (Double)s.pop();
          s.push(new Double (num2.doubleValue()/num.doubleValue()));
        break;
        case 17:
          num = (Double)s.pop();
          num2 = (Double)s.pop();
          s.push(new Double (Math.pow(num2.doubleValue(),num.doubleValue())));
        break;
        case 18:
          num = (Double)s.pop();
          s.push(new Double (Math.sin(num.doubleValue())));
        break;
        case 19:
          num = (Double)s.pop();
          s.push(new Double (Math.cos(num.doubleValue())));
        break;
        case 20:
          num = (Double)s.pop();
          s.push(new Double (Math.tan(num.doubleValue())));
        break;
      }
    }
  }

  boolean dtbool(Double d){//converts a double to a boolean (false if double is 0)
    if (d.doubleValue()==0)
      return false;
    else
      return true;
  }
  
}